// Copyright (C) 2005,  Lucian Constantin <struct_bylighting@yahoo.com>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


#include "ctagsdialog.h"
#ifdef USING_QT4
#include <Q3VBoxLayout>
#include <q3hbox.h>
#include <q3accel.h>
#include <QLabel>
#endif
#ifdef USING_QT3
#include <qlayout.h>
#include <qhbox.h>
#include <qaccel.h>
#include <qlabel.h>
#endif

#include <qcheckbox.h>
#include <qpushbutton.h>
#include "global.h"




//*****************************************************************************/
// ctags dialog
//*****************************************************************************/
CtagsDialog::CtagsDialog(): QDialog(0, "ctags selection", true) {
	Q3VBoxLayout *vly = new Q3VBoxLayout(this, 10);
	vly->setAutoAdd(true);

	Q3HBox *hbox3 = new Q3HBox(this);
	hbox3->setSpacing(10);
#ifdef    ENABLE_STDLIBC_CTAGS
	load_stdlib_ = new QCheckBox(hbox3);
	if (Global::instance()->load_glibc_tags)
#ifdef USING_QT4
		load_stdlib_->setOn(true);
#else
		load_stdlib_->setChecked(true);
#endif	
	label1_ = new QLabel("Load Standard C Library tags", hbox3);
#endif //ENABLE_STDLIBC_CTAGS

	Q3HBox *hbox0 = new Q3HBox(this);
	hbox0->setSpacing(10);
	new QLabel("Use exuberant-ctags to generate TAGS file", hbox0);
	Q3HBox *hbox1 = new Q3HBox(this);
	hbox0->setSpacing(10);
	new QLabel("and press \"Reload tags\" to start using it.", hbox1);

	// accept/reject
	Q3HBox *hbox2 = new Q3HBox(this);
	hbox2->setSpacing(10);
	button_reload_ = new QPushButton("Reload tags", hbox2);
	button_cancel_ = new QPushButton("Cancel", hbox2);


	connect(button_reload_, SIGNAL(clicked()), SLOT(accept()));
	connect(button_cancel_, SIGNAL(clicked()), SLOT(reject()));
}

bool CtagsDialog::getLibc() {
#ifdef    ENABLE_STDLIBC_CTAGS
	return load_stdlib_->isChecked();
#else
	return false;
#endif
}



