//****************************************************************************
// Copyright (C) 2005,  Lucian Constantin <struct_bylighting@yahoo.com>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//****************************************************************************

#ifndef SYNTAX_H
#define SYNTAX_H

#include "global.h"
#ifdef USING_QT3
#include <qsyntaxhighlighter.h>
#endif
#ifdef USING_QT4
#include <q3syntaxhighlighter.h>
#endif

// generic xml
class XMLSyntaxHighlighter : public Q3SyntaxHighlighter {
public:
	XMLSyntaxHighlighter(Q3TextEdit *textEdit);
	virtual ~XMLSyntaxHighlighter(void);

	int highlightParagraph(const QString &text, int endStateOfLastPara);
};

// c/c++/java/javascript
class CBasedSyntaxHighlighter : public Q3SyntaxHighlighter {
public:
	CBasedSyntaxHighlighter(Q3TextEdit *textEdit, char **keyw);
	virtual ~CBasedSyntaxHighlighter(void);

	int highlightParagraph(const QString &text, int endStateOfLastPara);
private:
	int checkKeyword(const QString &text);
	char **keyw_;
};

// the result of diff command
class DiffSyntaxHighlighter : public Q3SyntaxHighlighter {
public:
	DiffSyntaxHighlighter(Q3TextEdit *textEdit);
	virtual ~DiffSyntaxHighlighter(void);

	int highlightParagraph(const QString &text, int endStateOfLastPara);
private:
	int checkKeyword(const QString &text);
};


// NASM/GAS assembler
class AsmSyntaxHighlighter : public Q3SyntaxHighlighter {
public:
	AsmSyntaxHighlighter(Q3TextEdit *textEdit);
	virtual ~AsmSyntaxHighlighter(void);

	int highlightParagraph(const QString &text, int endStateOfLastPara);
private:
	int checkKeyword(const QString &text);
};


// qmake/perl
class ScriptBasedSyntaxHighlighter : public Q3SyntaxHighlighter {
public:
	ScriptBasedSyntaxHighlighter(Q3TextEdit *textEdit, char **keyw);
	virtual ~ScriptBasedSyntaxHighlighter(void);

	int highlightParagraph(const QString &text, int endStateOfLastPara);
private:
	int checkKeyword(const QString &text);
	char **keyw_;
};




#endif

